         title    Treeview

         .586
         .model   flat, STDCALL
         option   casemap: none   ; Case sensitive

            include  \MASM32V1\include\windows.inc  
            include  \MASM32V1\include\kernel32.inc 
            include  \MASM32V1\include\user32.inc
            include  \Masm32V1\include\gdi32.inc
            include  \MASM32V1\include\comctl32.inc 
            include  \MASM32V1\include\imagehlp.inc

;         include   \MASM32V1\include\DSPMACRO.asm

         includelib  \MASM32V1\lib\kernel32.lib       
         includelib  \MASM32V1\lib\user32.lib
         includelib  \Masm32V1\lib\gdi32.lib
         includelib  \MASM32V1\lib\comctl32.lib
         includelib  \MASM32V1\LIB\imagehlp.LIB

         WinMain       PROTO
         InitTree      PROTO :DWORD, :DWORD
         GetDirs       PROTO :DWORD, :DWORD
         FillTree      PROTO :DWORD
         TreeNotify    PROTO :DWORD
         TreeBranch    PROTO :DWORD
         PathProc      PROTO :DWORD, :DWORD, :DWORD, :DWORD

MOVmd    MACRO Var1, Var2
         push     Var2
          pop     Var1
         ENDM

.const

ID_TREEVIEW     equ    1002h
MainMenu        equ    1002 
IDM_QUIT        equ    1005
IDM_ABOUT       equ    1006
IDB_TREE        equ    4006


WndClassName   db       'Treeview2',0
AppName        db       'Tree View 2',0
ToolClass      db       'ToolbarWindow32',0
ComboClass     db       'combobox',0
StaticClass    db       'static',0
ButtClass      db       'button',0
TreeClass      db       'SysTreeView32',0
szSelDrive     db       'Select A Drive Then',0
szButt         db       'Enter A Path',0
szAboutText    db       'Treeview of a Drive ',0ah,0ah
               db       'Ewayne Wagner',0ah
               db       'yooper@kalamazoo.net',0

.data
Parent         db       'L:',0
Loaded         dd       0
ExpCol         dd       0

szBackS        db       '\',0
szEnd          db       '*.*',0
szDir          db       'L:\*.*',0
DriveLetter    db       'C:\',0
szLetter       db       '[ ]',0
;szTest         db       'L:\Masm32V1\Programs\AsmEdit\Programs\AsmEdit\',0

.data?
hInst          dd       ?       
hWnd           dd       ?
hWndTool2      dd       ?
hDrivesLet     dd       ?
hSelDrive      dd       ?
hButt          dd       ?
hWndTree       dd       ?
hImageList     dd       ?
hParent        dd       ?
hItem          dd       ?
ItemNew        dd       ?
Lev            dd       ?
hSubDir        dd       32  dup(?)
hDir           dd       32  dup(?)
PathLen        dd       32  dup(?)
Test4          dd       ?
sw11           dd       ?
sw13           dd       ?

DriveArray     db       30  dup(?)
szLoadPath     db       256 dup(?)

msg            MSG                  <?>
tvis           TV_INSERTSTRUCT      <?>
.code

;-----------------------------------------------------------------------
start:                                          
      INVOKE     GetModuleHandle, 0          ; Get hModule (in eax)
         mov     hInst, eax                  ; hInst is same as HMODULE
        call     InitCommonControls          ; Initialize the common ctrl lib

      INVOKE     WinMain    

Exit:
      INVOKE     ExitProcess, eax

;-----------------------------------------------------------------------
WinMain PROC
LOCAL    wc:WNDCLASSEX

         mov     wc.cbSize, sizeof WNDCLASSEX    
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW                        
         mov     wc.lpfnWndProc, offset MainWndProc
         mov     wc.cbClsExtra, 0
         mov     wc.cbWndExtra, 0  
         mov     eax, hInst
         mov     wc.hInstance, eax
      INVOKE     LoadIcon, 0, IDI_APPLICATION
         mov     wc.hIcon, eax 
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, 0, IDC_SIZEWE
         mov     wc.hCursor, eax
         mov     wc.hbrBackground, COLOR_WINDOW
         mov     wc.lpszMenuName, MainMenu
         mov     wc.lpszClassName, offset WndClassName
    invoke       RegisterClassEx, addr wc                                    

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 350
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 400
         shr     eax, 1
         pop     ebx

      INVOKE     CreateWindowEx, WS_EX_ACCEPTFILES or WS_EX_APPWINDOW,\
                 addr WndClassName, addr AppName,\
                 WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,\
                 ebx, eax, 350, 400, NULL, NULL, hInst, NULL
        test     eax, eax     
          jz     GetOut
         mov     hWnd, eax

; Message Dispatch Loop        
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
         .break .if (!eax)
         INVOKE     TranslateMessage, addr msg
         INVOKE     DispatchMessage, addr msg
      .endw

GetOut:
         mov     eax, msg.wParam
         ret
WinMain ENDP

;-----------------------------------------------------------------------
MainWndProc PROC  hwnd:DWORD, uMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    tvi:TV_ITEM
LOCAL    hBitmap:DWORD
LOCAL    szWork1[64]:BYTE, szBuff0[256]

         mov     eax, uMsg
         cmp     eax, WM_NOTIFY
          je     wmnotify                        
         cmp     eax, WM_SIZE
          je     wmsize
         cmp     eax, WM_COMMAND
          je     wmcommand
         cmp     eax, WM_CREATE
          je     wmcreate
         cmp     eax, WM_DESTROY
          je     wmdestroy
      INVOKE     DefWindowProc, hwnd, uMsg, wParam, lParam
         jmp     return         

wmcommand:
         mov     eax, wParam
         and     eax, 0000FFFFh
      .if eax == IDM_QUIT
         INVOKE     PostQuitMessage, 0

      .elseif eax == IDM_ABOUT
         INVOKE     MessageBox, hwnd, addr szAboutText, addr AppName, MB_OK or MB_ICONQUESTION

      .elseif eax == 42         ; Path
         INVOKE     SendMessage, hButt, WM_KILLFOCUS, 0, 0
         INVOKE     CreateDialogParam, hInst, 4801, hWnd, offset PathProc, 0

      .elseif eax == 82         ; Combobox
            mov     ecx, wParam
            shr     ecx, 16

;---------- [Check for Combo selection] ----------
         .if ecx == CBN_SELCHANGE
            INVOKE     SendMessage, hDrivesLet, CB_GETCURSEL, 0, 0
               mov     ecx, eax
            INVOKE     SendMessage, hDrivesLet, CB_GETLBTEXT, ecx, addr szWork1
               mov     al, byte ptr szWork1+1
               mov     Parent, al
               mov     szDir, al
            INVOKE     lstrcpy, addr szBuff0, addr szDir
            INVOKE     InitTree, 2, addr szBuff0
         .endif
      .endif     
         jmp     Ret0

wmcreate:
; Initialize the tree view

      INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr ToolClass, 0,
                 WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or CCS_NODIVIDER or\
                 CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or WS_BORDER,\
                 0, 0, 1121, 22, hwnd, 0, hInst, 0
        test     eax, eax     
          jz     Ret0
         mov     hWndTool2, eax

      INVOKE     CreateWindowEx, 0, offset ComboClass, 0,
                 WS_VSCROLL or WS_VISIBLE or WS_CHILD or CBS_HASSTRINGS or\
                 CBS_DROPDOWN,
                 0, 0, 38, 250, hWndTool2, 82, hInst, 0
         mov     hDrivesLet, eax

      INVOKE     SendMessage, hDrivesLet, CB_SETITEMHEIGHT, -1, 14
      INVOKE     SendMessage, hDrivesLet, CB_SETITEMHEIGHT, 0, 14

        call     GetDrives

      INVOKE     CreateWindowEx, NULL, addr StaticClass, addr szSelDrive,
                 WS_CHILD or WS_VISIBLE,
                 40 ,4, 100, 18, hWndTool2, 40, hInst, NULL
         mov     hSelDrive, eax

      INVOKE     CreateWindowEx, NULL, addr ButtClass, addr szButt,
                 WS_CHILD or WS_VISIBLE,
                 150 ,1, 75, 16, hWndTool2, 42, hInst, NULL
         mov     hButt, eax

      INVOKE     GetClientRect, hwnd, addr rect     
         sub     rect.bottom, 23

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr TreeClass, 0,\
                 WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or\ 
                 TVS_LINESATROOT or WS_CLIPSIBLINGS,\
                 0, 23, rect.right, rect.bottom, hwnd, ID_TREEVIEW, hInst, NULL
        test     eax, eax     
          jz     Ret0
         mov     hWndTree, eax 

      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 5, 10
         mov     hImageList, eax
      INVOKE     LoadBitmap, hInst, IDB_TREE
         mov     hBitmap,eax
      INVOKE     ImageList_Add, hImageList, hBitmap, NULL
      INVOKE     DeleteObject, hBitmap
      INVOKE     SendMessage, hWndTree, TVM_SETIMAGELIST, 0, hImageList

      INVOKE     SendMessage, hWndTree, WM_GETFONT, 0, 0
        push     eax
      INVOKE     SendMessage, hDrivesLet, WM_SETFONT, eax, 1
         pop     eax
        push     eax
      INVOKE     SendMessage, hSelDrive, WM_SETFONT, eax, 1
         pop     eax
      INVOKE     SendMessage, hButt, WM_SETFONT, eax, 1

         jmp     Ret0

; Main window is being resized
wmsize:  
         mov     eax, lParam
         mov     edx, eax
         and     eax, 0ffffh
         shr     edx, 16
         sub     edx, 23
        push     eax
      INVOKE     MoveWindow, hWndTree, 0, 23, eax, edx, TRUE
         pop     eax
      INVOKE     MoveWindow, hWndTool2, 0, 0, eax, 22, TRUE
         jmp     Ret0

wmdestroy:
      INVOKE     DeleteObject, hImageList
      INVOKE     PostQuitMessage, NULL      
         jmp     Ret0

wmnotify:
      .if wParam == ID_TREEVIEW
         INVOKE     TreeNotify, lParam
            ret
      .endif

Ret0:
         xor     eax, eax

return:
         ret
MainWndProc ENDP

;===================================================
; Get the drive letters and load the combobox
;===================================================
GetDrives PROC
LOCAL     Cnt:DWORD

      INVOKE     GetLogicalDrives
         mov     ecx, eax
         shr     ecx, 2                             ; Skip test for drives A: & B:
         xor     edx, edx
      .while (ecx > 0)
            shr     ecx, 1
           push     edx
           push     ecx
         INVOKE     GetDriveType, addr DriveLetter  ; Get type of drive
            pop     ecx
            pop     edx

;---------- [If FIXED drive add the letter to the array] ----------
         .if eax == DRIVE_FIXED
               mov     al, byte ptr DriveLetter
               mov     DriveArray[edx], al
               inc     edx
         .endif
            inc     DriveLetter
      .endw
         mov     DriveArray[edx], 0

         INVOKE     lstrlen, addr DriveArray
            mov     Cnt, eax
            xor     eax, eax
         .while (Cnt)
               mov     dl, byte ptr DriveArray[eax]
               mov     byte ptr szLetter+1, dl
            INVOKE     SendMessage, hDrivesLet, CB_ADDSTRING, 0, addr szLetter
               inc     eax
               dec     Cnt
         .endw
         INVOKE     SendMessage, hDrivesLet, CB_SETCURSEL, 0, 0

         ret
GetDrives ENDP

;===================================================
; Initialize the Tree
;===================================================
InitTree PROC Code:DWORD, Input

      INVOKE     LockWindowUpdate, hWndTree          ; Lock parent to avoid flicker

      INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, TVI_ROOT
         mov     tvis.hParent, NULL
         mov     tvis.hInsertAfter, TVI_ROOT
         mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
         mov     tvis.item.pszText, offset Parent
         mov     tvis.item.iImage, 1
         mov     tvis.item.iSelectedImage, 1
      INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
         mov     ecx, Lev
         mov     hDir[ecx*4], eax
         mov     hParent, eax

      INVOKE     GetDirs, Code, Input
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hParent
      INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, hParent
      INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, NULL ;hParent
      INVOKE     LockWindowUpdate, 0
      INVOKE     SetFocus, hWndTree

         ret
InitTree ENDP

;===========================================================
; Get the Directories and Sub Directories and build the Tree
;===========================================================
GetDirs PROC Code:DWORD, Input
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    tvi:TV_ITEM
LOCAL    Dirs:DWORD, Cnt, hFind
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

         and     sw11, 0
      .if Code == 1
            mov     sw11, 1
      .endif

      INVOKE     lstrcpy, addr szBuff0, Input
;INVOKE     MessageBox, NULL, addr szBuff0, addr AppName, MB_OK
      INVOKE     FindFirstFile, addr szBuff0, addr FindData
        test     eax, eax
          js     NoFile
         mov     hFind, eax
         jmp     ChkDir

;_______________________________________________________________________
NextDir:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     AllDone ;GetDir

;_______________________________________________________________________
ChkDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         .if byte ptr FindData.cFileName == '.' || dword ptr FindData.cFileName == 'YCER' 
               jmp     NextDir
         .endif
         .if Code == 1
            INVOKE     lstrlen, addr szBuff0
               sub     eax, 3
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff0, eax
            INVOKE     lstrcat, addr szBuff1, addr szBackS
         .else
            INVOKE     lstrcpyn, addr szBuff1, addr szDir, 4
         .endif
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szDir+2
            mov     Lev, 0
         INVOKE     FillTree, addr FindData.cFileName
            jmp     GetSubDir
      .endif
            jmp     NextDir

;_______________________________________________________________________
GetSubDir:
      INVOKE     FindFirstFile, addr szBuff1, addr FindData
      .if eax == -1
            mov     Lev, 0
            jmp     NextDir
      .endif
         mov     ecx, Lev
         mov     hSubDir[ecx*4], eax
         jmp     ChkSubDir

;_______________________________________________________________________
NextSubDir:
         mov     ecx, Lev
      INVOKE     FindNextFile, hSubDir[ecx*4], addr FindData
      .if !eax                       ; eax = 0 = failure
            mov     ecx, Lev   
         INVOKE     FindClose, hSubDir[ecx*4]
            mov     Lev, 0
            jmp     NextDir
      .endif

;_______________________________________________________________________
ChkSubDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         .if byte ptr FindData.cFileName == '.'
               jmp     NextSubDir
         .endif
         INVOKE     lstrlen, addr szBuff1
            mov     ecx, Lev
            mov     PathLen[ecx*4], eax
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szDir+2
            inc     Lev
         .if Lev < 2
               mov     eax, hItem
               mov     tvi.hItem, eax
               mov     tvi.imask, TVIF_CHILDREN
               mov     tvi.cChildren, 1
            INVOKE     SendMessage, hWndTree, TVM_SETITEM, 0, addr tvi
         .endif
            jmp     GetSubDir
      .endif
         jmp     NextSubDir

AllDone:
NoFile:
      INVOKE     FindClose, hFind
         xor     eax, eax
         ret
GetDirs ENDP

;===================================================
; Fill the Tree with Directories and Sub Directories
;===================================================
FillTree PROC  uses ebx  DirName:DWORD

         mov     ebx, Lev   
         mov     eax, hDir[ebx*4]

      .if Lev == 0 && !sw11
            mov     eax, hParent
      .elseif Lev == 0 && sw11
            mov     eax, ItemNew
      .endif
         mov     tvis.hParent, eax
         mov     tvis.hInsertAfter, TVI_LAST
         mov     eax, DirName
         mov     tvis.item.pszText, eax
         mov     tvis.item.iImage, 3
         mov     tvis.item.iSelectedImage, 4
      INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
         mov     hItem, eax
         mov     ebx, Lev
         inc     ebx
         mov     hDir[ebx*4], eax

         xor     eax, eax
         ret
FillTree ENDP

;===================================================
; Notify for the Treeview
;===================================================
TreeNotify proc uses ebx lParam:DWORD
LOCAL    tvi:TV_ITEM
LOCAL    Sedi:DWORD
LOCAL    szWork1[64]:BYTE, szWork2[64], szBuff0[256], szBuff1[256]

            mov     eax, lParam
            mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
            mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
            mov     edx, (NM_TREEVIEW ptr [eax]).itemNew.state
; States
; 01h = Focused
; 02h = Selected
; 20h = Edpanded
; 40h = ExpandedOnce

         .if ebx == TVN_ITEMEXPANDING || ebx == TVN_SELCHANGINGA
;DSPValue hWnd, edx
            .if ebx == TVN_SELCHANGINGA
               .if ecx == hParent
                  .if sw13 == 13
                        and     sw13, 0
                        mov     eax, 1
                        ret
                  .endif
               .endif
                 test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
                   jz     Ret0
            .endif

;---------- [Retrive the path from the selected item] ----------
               and     sw11, 0
            .if edx && edx != 2 || ebx == TVN_SELCHANGINGA
                  mov     sw11, 14
            .endif

               mov     hItem, ecx
               mov     ItemNew, ecx
               mov     tvi.hItem, ecx
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork1
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
              push     edx
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
               pop     edx
               mov     eax, hItem
            .if !edx && eax == hParent
                  mov     sw13, 13
                  jmp     Ret0
            .endif
         
               lea     edi, szBuff1
               add     edi, 250
               mov     byte ptr[edi], 0
               mov     byte ptr[edi-1], '\'
               sub     edi, 2
               mov     Sedi, edi
            .while (eax != hParent)
               INVOKE     lstrlen, addr szWork1
                  mov     ebx, eax
                  mov     ecx, eax
                  mov     edi, Sedi
               .while (ecx)
                     mov     al, byte ptr szWork1[ebx-1]
                     mov     byte ptr[edi], al
                     dec     edi
                     dec     ebx
                     dec     ecx
               .endw
                  mov     byte ptr[edi], '\'
                  dec     edi
                  mov     Sedi, edi
               INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_PARENT, hItem
                  mov     hItem, eax
                  mov     tvi.hItem, eax
                  mov     tvi.imask, TVIF_TEXT
                  lea     eax, szWork1
                  mov     tvi.pszText, eax
                  mov     tvi.cchTextMax, 64
               INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
                  mov     eax, hItem
            .endw
               mov     edi, Sedi
               mov     byte ptr[edi], ':'
               mov     al, byte ptr szDir
               mov     byte ptr[edi-1], al
               sub     edi, 2
               lea     eax, szBuff1
               sub     edi, eax
               inc     edi
            INVOKE     lstrcpy, addr szBuff0, addr szBuff1[edi]
            INVOKE     lstrcpy, addr szLoadPath, addr szBuff0
            INVOKE     lstrcat, addr szBuff0, addr szEnd
            .if sw11 != 14
               INVOKE     GetDirs, 1, addr szBuff0
            .endif
            INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, ItemNew
            INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, ItemNew

         .elseif ebx == TVN_SELCHANGED
              test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
                jz     Ret0
               mov     tvi.hItem, ecx
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork1
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
               mov     byte ptr szBuff0, 0
            INVOKE     lstrlen, addr szWork1
            .if eax > 2 || byte ptr szWork1 != ':'                      ; Not root dir
               INVOKE     lstrcpy, addr szBuff0, addr szLoadPath
            .else
            INVOKE     lstrcat, addr szBuff0, addr szWork1
            INVOKE     lstrcat, addr szBuff0, addr szBackS
            .endif
            INVOKE     SendMessage, hWnd, WM_SETTEXT, 0, addr szBuff0
         .endif

Ret0:
         xor     eax, eax   
         ret
TreeNotify endp

;==============================================================
; Expand Tree to proper branch converts a path to a tree handle
;==============================================================
TreeBranch proc uses ebx esi  LoadPath:DWORD
LOCAL    tvi:TV_ITEM
LOCAL    LevelCnt:DWORD, Cnt, CntL, dwState, Match
LOCAL    szPath[256]:byte, szWork[64], szBuff[64]

         and     CntL, 0
         and     Match, 0
      INVOKE     lstrcpy, addr szPath, LoadPath

;---------- [Get the number of levels in the path] ----------
         lea     esi, szPath
         mov     LevelCnt, 1
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               add     LevelCnt, 1
         .endif
         inc     esi
      .endw

;---------- [Bypass the first path level] ----------
      INVOKE     lstrcpy, addr szPath, addr szPath+3

           push     hParent
            pop     hItem
            jmp     NextLev

;---------- [Use the path to expand the tree] ----------
      .while (ebx < LevelCnt)
         .if byte ptr szPath == 0   ; Last level
               and     Match, 0
               mov     dwState, TVIS_SELECTED or TVIS_BOLD
         .endif
;------------------- [First child item of the tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CHILD, hItem
           test     eax, eax
             jz     ret_ok
            mov     hItem, eax
            mov     tvi.hItem, eax
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
         INVOKE     lstrcmpi, addr szWork, addr szBuff
         .if eax == 0
               jmp     SetChild
         .endif

;------------------- [Greater then first item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .while (eax != 0) 
               mov     hItem, eax
               mov     tvi.hItem, eax
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
            INVOKE     lstrcmpi, addr szWork, addr szBuff
            .if eax == 0
                  jmp     SetChild
            .endif
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .endw
            jmp     NextLev

SetChild:
           push     hItem
         .if byte ptr szPath != 0    ; 0 = last folder
            INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
         .endif
            pop     hItem
            mov     eax, hItem
            mov     tvi.hItem, eax
         .if byte ptr szPath != 0    ; 0 = last folder
               mov     tvi.imask, TVIF_CHILDREN
               mov     tvi.cChildren, 1
         .endif
         INVOKE     SendMessage, hWndTree, TVM_SETITEM, 0, addr tvi
            inc     Match

;------------------- [Get the directory for the next level] -------------------
NextLev:
         .if byte ptr szPath == 0 && Match
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, hItem
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hItem
               jmp     ret_ok
         .elseif byte ptr szPath == 0 && !Match
;            INVOKE     MessageBox, NULL, addr szError3, addr szLoadPath, MB_OK or MB_ICONINFORMATION
               jmp     ret_ok
         .endif
            mov     szBuff, 0
            xor     eax, eax
            lea     esi, szPath
         .while (byte ptr[esi]) != 0
            .if byte ptr[esi] == '\'
                  inc     eax
               INVOKE     lstrcpyn, addr szBuff, addr szPath, eax
                  inc     esi
               INVOKE     lstrcpy, addr szPath, esi
               .break
            .endif
               inc     eax
               inc     esi
         .endw
         .if byte ptr szBuff == 0
               jmp     ret_ok
         .endif
            add     CntL, 1
            mov     ebx, CntL
      .endw

ret_ok:
         ret
TreeBranch endp

;=========================================================================
; Enter path PROCEDURE
;=========================================================================
PathProc PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    szBuff0[256]:BYTE

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         jne     DlgDone
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, 402
          je     Expand
         cmp     eax, IDCANCEL         ; that was pressed
          je     CancleIt              ; and if not either of these
         jmp     DlgDone

Expand:
      INVOKE     GetDlgItemText, hdlg, 401, addr szBuff0, 250
      INVOKE     LockWindowUpdate, hWndTree          ; Lock parent to avoid flicker
      INVOKE     TreeBranch, addr szBuff0
      INVOKE     LockWindowUpdate, 0

CancleIt:
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret
PathProc endp

end start
;INVOKE     MessageBox, NULL, addr szPath, addr AppName, MB_OK
